#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include "7z.h"
#include "LiteralCoder.h"

void usage(char *program)
{
    printf("Usage: %s input_file output_file start_offset\n", program);
}

int main(int argc, char **argv)
{
    unsigned char *indata;
    unsigned char *outdata;
    unsigned int inlength, outlength, uiTmp;
    long int lstart_offset;
    int iResult;
    int iReturn;
    unsigned long outlengthc;        
    struct stat s;
    
    if (argc != 4) {
	usage(argv[0]);
	exit(0);
    }
    
    if (stat(argv[1], &s) != 0) {
	printf("Error: stat\nFile %s doesn't exist\nFAILED with code -1\n", argv[1]);
	exit(-1);
    }
    
    lstart_offset = strtol(argv[3], NULL, 10);
    inlength = s.st_size - (unsigned int) lstart_offset;
    outlength = 4194304;
    
    printf("Length: %d\n", inlength);
    
    indata = (unsigned char *) malloc(inlength);
    outdata = (unsigned char *) malloc(outlength);
    
    FILE *f = fopen(argv[1], "rb");
    uiTmp = fread(indata, (size_t) lstart_offset, 1 , f);
    uiTmp = fread(indata, inlength, 1 , f);
    printf("Read: %d\n", uiTmp);
    fclose(f);

    iResult = decompress_lzma_7z(indata, inlength, outdata, outlength);    
    for (outlengthc = outlength - 1; outdata[outlengthc] == '\0'; outlengthc--) {
    }
    printf("Decompression function returns: %d\n", iResult);
    if (iResult == 0) {
        f = fopen(argv[2], "wb");
	fwrite(outdata, outlengthc + 1, 1, f);
	fclose(f);
	iReturn = 0;
    } else {
	iReturn = -2;
    }
    
    free(indata);
    free(outdata);
    
    if (iReturn == 0) {
	printf("SUCCESS\n");
    } else {
	printf("FAILED with code %d\n", iReturn);
    }	
    return iReturn;
}

